// AButtonDispatch.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "ButtonDispatch.h"
#include "AButtonDispatch.h"

#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Note: we add support for IID_IAButtonDispatch to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {2BC41DB2-422F-11D0-A1A9-000000000000}
static const IID IID_IAButtonDispatch =
{ 0x2bc41db2, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB3-422F-11D0-A1A9-000000000000}
static const IID IID_IAButtonEvents =
{ 0x2bc41db3, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB4-422F-11D0-A1A9-000000000000}
// coclass!
static const GUID CLSID_AButton =
{ 0x2bc41db4, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// Use OLETYPELIB of master dialog?
IMPLEMENT_OLETYPELIB(CAButtonDispatch, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// CAButtonDispatch

IMPLEMENT_DYNCREATE(CAButtonDispatch, CButtonDispatch)

CAButtonDispatch::CAButtonDispatch()
{
	m_piidEvents = &IID_IAButtonEvents;
	m_piidPrimary = &IID_IAButtonDispatch;
}

CAButtonDispatch::~CAButtonDispatch()
{
}

HRESULT CAButtonDispatch::GetClassID(LPCLSID pclsid)
{
	*pclsid = CLSID_AButton;
	return NOERROR;
}

void CAButtonDispatch::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CButtonDispatch::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CAButtonDispatch, CButtonDispatch)
	//{{AFX_MSG_MAP(CAButtonDispatch)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CAButtonDispatch, CButtonDispatch)
	//{{AFX_DISPATCH_MAP(CAButtonDispatch)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CAButtonDispatch, CButtonDispatch)
	INTERFACE_PART(CAButtonDispatch, IID_IAButtonDispatch, Dispatch)
END_INTERFACE_MAP()

BEGIN_EVENT_MAP(CAButtonDispatch, CButtonDispatch)
	//{{AFX_EVENT_MAP(CAButtonDispatch)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// CAButtonDispatch message handlers
