// ButtonDispatch.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "ButtonDispatch.h"
#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Derived classes must create 3 guids - coclass, primary dispatch interface, and event interface
// Derived classes must use IMPLEMENT_OLECREATE

/////////////////////////////////////////////////////////////////////////////
// CButtonDispatch

IMPLEMENT_DYNCREATE(CButtonDispatch, CCmdTargetPlus)

CButtonDispatch::CButtonDispatch()
{
}

CButtonDispatch::~CButtonDispatch()
{
}

HRESULT CButtonDispatch::GetClassID(LPCLSID pclsid)
{
	return E_NOTIMPL;
}

void CButtonDispatch::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTargetPlus::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CButtonDispatch, CCmdTargetPlus)
	//{{AFX_MSG_MAP(CButtonDispatch)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CButtonDispatch, CCmdTargetPlus)
	//{{AFX_DISPATCH_MAP(CButtonDispatch)
	DISP_FUNCTION(CButtonDispatch, "Press", Press, VT_EMPTY, VTS_NONE)
	DISP_PROPERTY_EX_ID(CButtonDispatch, "Caption", DISPID_CAPTION, GetCaption, SetCaption, VT_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/*BEGIN_INTERFACE_MAP(CButtonDispatch, CCmdTargetPlus)
	INTERFACE_PART(CButtonDispatch, IID_IDispatch, Dispatch)
END_INTERFACE_MAP()*/

BEGIN_EVENT_MAP(CButtonDispatch, CCmdTargetPlus)
	//{{AFX_EVENT_MAP(CButtonDispatch)
	EVENT_CUSTOM("OnClick", FireOnClick, VTS_NONE)
	EVENT_CUSTOM("OnMouseOver", FireOnMouseOver, VTS_NONE)
	EVENT_CUSTOM("OnFocus", FireOnFocus, VTS_BOOL)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// CButtonDispatch message handlers

void CButtonDispatch::Press() 
{
	HWND hWnd = m_pThisWnd->GetSafeHwnd();

	m_pThisWnd->SendMessage(WM_COMMAND, MAKEWPARAM(BN_CLICKED, ::GetWindowLong(hWnd, GWL_ID)), (LPARAM)hWnd);

}

BSTR CButtonDispatch::GetCaption() 
{
	CString strResult;

	m_pThisWnd->GetWindowText(strResult);

	return strResult.AllocSysString();
}

void CButtonDispatch::SetCaption(LPCTSTR lpszNewValue) 
{
	m_pThisWnd->SetWindowText(lpszNewValue);
}
