// ButtonDispatch.h : header file
//

#ifndef __ButtonDISPATCH_H__
#define __ButtonDISPATCH_H__

#include "CmdTargetPlus.h"

/////////////////////////////////////////////////////////////////////////////
// CButtonDispatch command target

class CButtonDispatch : public CCmdTargetPlus
{
	DECLARE_DYNCREATE(CButtonDispatch)

public:
	CButtonDispatch();           // protected constructor used by dynamic creation
	virtual ~CButtonDispatch();

// Attributes
public:
	CWnd* m_pThisWnd;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CButtonDispatch)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CButtonDispatch)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CButtonDispatch)
	afx_msg void Press();
	afx_msg BSTR GetCaption();
	afx_msg void SetCaption(LPCTSTR lpszNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	//DECLARE_INTERFACE_MAP()

	DECLARE_EVENT_MAP()


public:
	// Event maps
	//{{AFX_EVENT(CButtonDispatch)
	void FireOnClick()
		{FireEvent(eventidOnClick,EVENT_PARAM(VTS_NONE));}
	void FireOnMouseOver()
		{FireEvent(eventidOnMouseOver,EVENT_PARAM(VTS_NONE));}
	void FireOnFocus(BOOL bSet)
		{FireEvent(eventidOnFocus,EVENT_PARAM(VTS_BOOL), bSet);}
	//}}AFX_EVENT

public:
	HRESULT GetClassID(LPCLSID pclsid);

public:
	enum {
	//{{AFX_DISP_ID(CButtonDispatch)
	dispidPress = 1L,
	eventidOnClick = 1L,
	eventidOnMouseOver = 2L,
	eventidOnFocus = 3L,
	//}}AFX_DISP_ID
	};

};

/////////////////////////////////////////////////////////////////////////////

#endif // __ButtonDISPATCH_H__
