// EventsEdit.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "EventsEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventsEdit

CEventsEdit::CEventsEdit()
{
}

CEventsEdit::~CEventsEdit()
{
}


BEGIN_MESSAGE_MAP(CEventsEdit, CEdit)
	//{{AFX_MSG_MAP(CEventsEdit)
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_MOUSEMOVE()
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventsEdit message handlers

void CEventsEdit::OnKillFocus(CWnd* pNewWnd) 
{
	ASSERT_VALID(m_pDisp); // did you remember to connect the dispatch implementation?
	CEdit::OnKillFocus(pNewWnd);
	
	VARIANT vtFalse;
	vtFalse.vt = VT_BOOL;
	vtFalse.boolVal = VARIANT_FALSE;

	m_pDisp->FireOnFocus(vtFalse);
}

void CEventsEdit::OnSetFocus(CWnd* pOldWnd) 
{
	ASSERT_VALID(m_pDisp); // did you remember to connect the dispatch implementation?
	CEdit::OnSetFocus(pOldWnd);

	VARIANT vtTrue;
	vtTrue.vt = VT_BOOL;
	vtTrue.boolVal = VARIANT_TRUE;

	m_pDisp->FireOnFocus(vtTrue);
}

void CEventsEdit::OnMouseMove(UINT nFlags, CPoint point) 
{
	ASSERT_VALID(m_pDisp); // did you remember to connect the dispatch implementation?
	CEdit::OnMouseMove(nFlags, point);

	m_pDisp->FireOnMouseOver();
}

void CEventsEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	ASSERT_VALID(m_pDisp); // did you remember to connect the dispatch implementation?
	CEdit::OnChar(nChar, nRepCnt, nFlags);

	// allocate BSTR and set first character to nChar
	CString str = (char)nChar;
	COleVariant vtStrOneChar(str);
	
	m_pDisp->FireOnChar(vtStrOneChar);
}
