// LBoxDispatch.h : header file
//

#ifndef __LBOXDISPATCH_H__
#define __LBOXDISPATCH_H__

class CMfcaxscrvbDlg;

#include "CmdTargetPlus.h"

/////////////////////////////////////////////////////////////////////////////
// CLBoxDispatch command target

class CLBoxDispatch : public CCmdTargetPlus
{
	DECLARE_DYNCREATE(CLBoxDispatch)

	CLBoxDispatch();           // protected constructor used by dynamic creation
	virtual ~CLBoxDispatch();

// Attributes
public:
	CWnd* m_pThisWnd;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLBoxDispatch)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:


	// Generated message map functions
	//{{AFX_MSG(CLBoxDispatch)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CLBoxDispatch)
	afx_msg void AddString(const VARIANT FAR& strAdd);
	afx_msg void ClearList();
	afx_msg void RemoveString(const VARIANT FAR& strRemove);
	afx_msg void SelectString(const VARIANT FAR& strSelect);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
	DECLARE_EVENT_MAP()

	DECLARE_OLETYPELIB(CLBoxDispatch)

public:
	enum {
	//{{AFX_DISP_ID(CLBoxDispatch)
	dispidAddString = 1L,
	dispidClearList = 2L,
	dispidRemoveString = 3L,
	dispidSelectString = 4L,
	eventidOnMouseOver = 1L,
	eventidOnFocus = 2L,
	eventidOnSelCancel = 3L,
	eventidOnSelChange = 4L,
	//}}AFX_DISP_ID
	};

	// Event maps
	//{{AFX_EVENT(CLBoxDispatch)
	void FireOnMouseOver()
		{FireEvent(eventidOnMouseOver,EVENT_PARAM(VTS_NONE));}
	void FireOnFocus(BOOL bSet)
		{FireEvent(eventidOnFocus,EVENT_PARAM(VTS_BOOL), bSet);}
	void FireOnSelCancel(const VARIANT FAR& strCancelled)
		{FireEvent(eventidOnSelCancel,EVENT_PARAM(VTS_VARIANT), &strCancelled);}
	void FireOnSelChange(const VARIANT FAR& strSelection)
		{FireEvent(eventidOnSelChange,EVENT_PARAM(VTS_VARIANT), &strSelection);}
	//}}AFX_EVENT

public:
	HRESULT GetClassID(LPCLSID pclsid);

};

/////////////////////////////////////////////////////////////////////////////

#endif  // __LBOXDISPATCH_H__
