// CancelDispatch.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "ButtonDispatch.h"
#include "CancelDispatch.h"

#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Note: we add support for IID_ICancelDispatch to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {2BC41DB2-422F-11D0-A1A9-000000000000}
static const IID IID_ICancelDispatch =
{ 0xb2c1a34c, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB3-422F-11D0-A1A9-000000000000}
static const IID IID_ICancelEvents =
{ 0xb2c1a34d, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB4-422F-11D0-A1A9-000000000000}
// coclass!
static const GUID CLSID_Cancel =
{ 0xb2c1a34e, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// Use OLETYPELIB of master dialog?
IMPLEMENT_OLETYPELIB(CCancelDispatch, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// CCancelDispatch

IMPLEMENT_DYNCREATE(CCancelDispatch, CButtonDispatch)

CCancelDispatch::CCancelDispatch()
{
	m_piidEvents = &IID_ICancelEvents;
	m_piidPrimary = &IID_ICancelDispatch;
}

CCancelDispatch::~CCancelDispatch()
{
}

HRESULT CCancelDispatch::GetClassID(LPCLSID pclsid)
{
	*pclsid = CLSID_Cancel;
	return NOERROR;
}

void CCancelDispatch::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CButtonDispatch::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CCancelDispatch, CButtonDispatch)
	//{{AFX_MSG_MAP(CCancelDispatch)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CCancelDispatch, CButtonDispatch)
	//{{AFX_DISPATCH_MAP(CCancelDispatch)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CCancelDispatch, CButtonDispatch)
	INTERFACE_PART(CCancelDispatch, IID_ICancelDispatch, Dispatch)
END_INTERFACE_MAP()

BEGIN_EVENT_MAP(CCancelDispatch, CButtonDispatch)
	//{{AFX_EVENT_MAP(CCancelDispatch)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// CCancelDispatch message handlers
