// EditConDispatch.h : header file
//

#ifndef __EDITCONDISPATCH_H__
#define __EDITCONDISPATCH_H__

#include "CmdTargetPlus.h"

class CMfcaxscrvbDlg;

/////////////////////////////////////////////////////////////////////////////
// CEditConDispatch command target

class CEditConDispatch : public CCmdTargetPlus
{
	DECLARE_DYNCREATE(CEditConDispatch)

	CEditConDispatch();           // protected constructor used by dynamic creation
	virtual ~CEditConDispatch();

// Attributes
public:
	CWnd* m_pThisWnd;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditConDispatch)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEditConDispatch)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CEditConDispatch)
	afx_msg VARIANT AppendLine(const VARIANT FAR& strToAdd);
	afx_msg VARIANT InsertLine(const VARIANT FAR& strToAdd, const VARIANT FAR& nWhere);
	afx_msg VARIANT RemoveLine(const VARIANT FAR& nWhere);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
	DECLARE_EVENT_MAP()

	DECLARE_OLETYPELIB(CEditConDispatch)

public:
	enum {
	//{{AFX_DISP_ID(CEditConDispatch)
	dispidAppendLine = 1L,
	dispidInsertLine = 2L,
	dispidRemoveLine = 3L,
	eventidOnMouseOver = 1L,
	eventidOnChar = 2L,
	eventidOnFocus = 3L
	//}}AFX_DISP_ID
	};

	// Event maps
	//{{AFX_EVENT(CEditConDispatch)
	void FireOnMouseOver()
		{FireEvent(eventidOnMouseOver,EVENT_PARAM(VTS_NONE));}
	void FireOnChar(const VARIANT FAR& strChar)
		{FireEvent(eventidOnChar,EVENT_PARAM(VTS_VARIANT), &strChar);}
	void FireOnFocus(const VARIANT FAR& bSet)
		{FireEvent(eventidOnFocus,EVENT_PARAM(VTS_VARIANT), &bSet);}
	//}}AFX_EVENT


public:
	HRESULT GetClassID(LPCLSID pclsid);
};

/////////////////////////////////////////////////////////////////////////////

#endif //__EDITCONDISPATCH_H__
