// EventsButton.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "ButtonDispatch.h"
#include "EventsButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventsButton

CEventsButton::CEventsButton()
{
}

CEventsButton::~CEventsButton()
{
}


BEGIN_MESSAGE_MAP(CEventsButton, CButton)
	//{{AFX_MSG_MAP(CEventsButton)
	ON_WM_MOUSEMOVE()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
	ON_CONTROL_REFLECT_EX(BN_CLICKED, OnClicked)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventsButton message handlers

BOOL CEventsButton::OnClicked() 
{
	m_pDisp->FireOnClick();	

	return FALSE; // We're not handling, just observing
}

void CEventsButton::OnMouseMove(UINT nFlags, CPoint point) 
{	
	CButton::OnMouseMove(nFlags, point);

	m_pDisp->FireOnMouseOver();
}

void CEventsButton::OnSetFocus(CWnd* pOldWnd) 
{
	CButton::OnSetFocus(pOldWnd);
	
	m_pDisp->FireOnFocus(TRUE);
	
}

void CEventsButton::OnKillFocus(CWnd* pNewWnd) 
{
	CButton::OnKillFocus(pNewWnd);
	
	m_pDisp->FireOnFocus(FALSE);
	
}
