// EventsListBox.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "EventsListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventsListBox

CEventsListBox::CEventsListBox()
{
}

CEventsListBox::~CEventsListBox()
{
}


BEGIN_MESSAGE_MAP(CEventsListBox, CListBox)
	//{{AFX_MSG_MAP(CEventsListBox)
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_CONTROL_REFLECT(LBN_SELCHANGE, OnSelchange)
	ON_CONTROL_REFLECT(LBN_SELCANCEL, OnSelcancel)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventsListBox message handlers

void CEventsListBox::OnSetFocus(CWnd* pOldWnd) 
{
	ASSERT_VALID(m_pDisp); // Did you remember to hook me up to the dispatch implementation?
	CListBox::OnSetFocus(pOldWnd);
	
	m_pDisp->FireOnFocus(TRUE);	
}

void CEventsListBox::OnKillFocus(CWnd* pNewWnd) 
{
	ASSERT_VALID(m_pDisp); // Did you remember to hook me up to the dispatch implementation?
	CListBox::OnKillFocus(pNewWnd);
	
	m_pDisp->FireOnFocus(FALSE);	
}

void CEventsListBox::OnSelchange() 
{
	ASSERT_VALID(m_pDisp); // Did you remember to hook me up to the dispatch implementation?
	
	CString str;

	GetText(GetCurSel(), str);

	COleVariant vtStr(str);

	m_pDisp->FireOnSelChange(vtStr);
}

void CEventsListBox::OnSelcancel() 
{
	ASSERT_VALID(m_pDisp); // Did you remember to hook me up to the dispatch implementation?

	CString str;

	GetText(GetCurSel(), str);

	COleVariant vtStr(str);
	
	m_pDisp->FireOnSelCancel(vtStr);	
}

void CEventsListBox::OnMouseMove(UINT nFlags, CPoint point) 
{
	ASSERT_VALID(m_pDisp); // Did you remember to hook me up to the dispatch implementation?
	CListBox::OnMouseMove(nFlags, point);

	m_pDisp->FireOnMouseOver();
}
