// mfcaxscrvbDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include <initguid.h> // Realizes CLSID definitions
#include "msscript.h" // defines CLSIDs for VBScript and JScript
#include <activscp.h> // Active Scripting Interfaces
#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// {090D02B1-41D3-11D0-A1A9-000000000000}
const GUID CDECL BASED_CODE _tlid =
		{ 0x090D02B1, 0x41D3, 0x11d0, { 0xa1, 0xa9, 0, 0, 0, 0, 0, 0 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BEGIN_MESSAGE_MAP(CMfcaxscrvbDlg, CDialog)
	//{{AFX_MSG_MAP(CMfcaxscrvbDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RUNSCRIPT, OnRunScript)
	ON_BN_CLICKED(IDC_BBUTTON, OnBbuttonClicked)
	ON_BN_CLICKED(IDC_OPEN_DEBUGGER, OnOpenDebugger)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcaxscrvbDlg dialog

CMfcaxscrvbDlg::CMfcaxscrvbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcaxscrvbDlg::IDD, pParent)
{
	EnableAutomation();

	//{{AFX_DATA_INIT(CMfcaxscrvbDlg)
	m_bBreakOnStart = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


	// XX ActiveX Scripting XX
	m_axsp = NULL;
	m_axs  = NULL;
	m_bScriptIsRunning = FALSE;

	// XX ActiveX Scripting Debugging XX
   m_pdm             = NULL;
   m_pDebugApp       = NULL;
   m_pDebugDocHelper = NULL;
   m_dwAppCookie     = 0;

	// Hook up windows objects to their dispatch implementations
	// so they can fire COM events when Windows events occur
	m_wndAButton.m_pDisp	 = &m_xAButtonDispatch;
	m_wndBButton.m_pDisp	 = (CButtonDispatch*)&m_xBButtonDispatch;
	m_wndRunScript.m_pDisp	 = (CButtonDispatch*)&m_xRunScriptDispatch;
	m_wndLBox.m_pDisp		 = &m_xLBoxDispatch;
	m_wndEditCon.m_pDisp	 = &m_xEditConDispatch;
	m_wndOK.m_pDisp          = &m_xOKDispatch;
	m_wndCancel.m_pDisp      = &m_xCancelDispatch;

	// vice versa, so dispatch implementations can affect windows
	m_xAButtonDispatch.m_pThisWnd	 = &m_wndAButton;
	m_xBButtonDispatch.m_pThisWnd = &m_wndBButton;
	m_xRunScriptDispatch.m_pThisWnd = &m_wndRunScript;
	m_xLBoxDispatch.m_pThisWnd		 = &m_wndLBox;
	m_xEditConDispatch.m_pThisWnd	 = &m_wndEditCon;
	m_xOKDispatch.m_pThisWnd = &m_wndOK;
	m_xCancelDispatch.m_pThisWnd = &m_wndCancel;

	// XX ActiveX Scripting XX
}

CMfcaxscrvbDlg::~CMfcaxscrvbDlg()
{
	// XX ActiveX Scripting XX
	if (m_axsp)
   {
		m_axsp->Release();
      m_axsp = NULL;
   }

	if (m_axs)
	{
		m_axs->Close();
		m_axs->Release();
      m_axs = NULL;
	}
	// XX ActiveX Scripting XX

	// XX ActiveX Scripting Debugging XX
   if (m_pDebugApp)
   {
      m_pDebugApp->Release();
      m_pDebugApp = NULL;
   }
   if (m_pdm)
   {
      m_pdm->Release();
      m_pdm = NULL;
   }
	// XX ActiveX Scripting Debugging XX
}

void CMfcaxscrvbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcaxscrvbDlg)
	DDX_Control(pDX, IDC_BBUTTON, m_wndBButton);
	DDX_Control(pDX, IDC_RUNSCRIPT, m_wndRunScript);
	DDX_Control(pDX, IDC_EDCON, m_wndEditCon);
	DDX_Control(pDX, IDC_ABUTTON, m_wndAButton);
	DDX_Control(pDX, IDC_LBOX, m_wndLBox);
	DDX_Control(pDX, IDC_BROCON, m_wndBroCon);
	DDX_Control(pDX, IDOK, m_wndOK);
	DDX_Control(pDX, IDCANCEL, m_wndCancel);
	DDX_Check(pDX, IDC_CHECK_BREAK_ON_START, m_bBreakOnStart);
	//}}AFX_DATA_MAP
}


void CMfcaxscrvbDlg::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CMfcaxscrvbDlg::OnFinalRelease();
}

/////////////////////////////////////////////////////////////////////////////
// CMfcaxscrvbDlg Active Scripting Support
// XX ActiveX Scripting XX

BEGIN_DISPATCH_MAP(CMfcaxscrvbDlg, CDialog)
	//{{AFX_DISPATCH_MAP(CMfcaxscrvbDlg)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "BroCon", GetBroCon, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "EditCon", GetEditCon, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "AButton", GetAButton, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "BButton", GetBButton, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "LBox", GetLBox, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "RunScript", GetScriptButton, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "OKButton", GetOKButton, SetNotSupported, VT_DISPATCH)
	DISP_PROPERTY_EX(CMfcaxscrvbDlg, "CancelButton", GetCancelButton, SetNotSupported, VT_DISPATCH)
	DISP_FUNCTION(CMfcaxscrvbDlg, "HostCreateObject", HostCreateObject, VT_DISPATCH, VTS_VARIANT)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IMfcaxscrvbDialog to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {2BC41DB0-422F-11D0-A1A9-000000000000}
static const IID IID_IMfcaxscrvbDlg =
{ 0x2bc41db0, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB0-422F-11D0-A1A9-000000000000}
/*static const IID IID_IMfcaxscrvbDlgEvents =
{ 0x2bc41db0, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };*/

// {2BC41DB1-422F-11D0-A1A9-000000000000}
static const GUID CLSID_MfcaxscrvbDlg =
{ 0x2bc41db1, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CMfcaxscrvbDlg, _tlid, _wVerMajor, _wVerMinor)

BOOL CMfcaxscrvbDlg::GetDispatchIID(IID* piid)
{
	*piid = CLSID_MfcaxscrvbDlg;

	return TRUE;
}

BEGIN_INTERFACE_MAP(CMfcaxscrvbDlg, CDialog)
	INTERFACE_PART(CMfcaxscrvbDlg, IID_IActiveScriptSite, ActiveScriptSite)
	INTERFACE_PART(CMfcaxscrvbDlg, IID_IActiveScriptSiteWindow, ActiveScriptSiteWindow)
	INTERFACE_PART(CMfcaxscrvbDlg, IID_IActiveScriptSiteDebug, ActiveScriptSiteDebug)
	INTERFACE_PART(CMfcaxscrvbDlg, IID_IDebugDocumentHost, DebugDocumentHost)
	INTERFACE_PART(CMfcaxscrvbDlg, IID_IMfcaxscrvbDlg, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IActiveScriptSite Implementation

STDMETHODIMP_(ULONG)CMfcaxscrvbDlg::XActiveScriptSite::AddRef()
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)
    return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG)CMfcaxscrvbDlg::XActiveScriptSite::Release()
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)
    return pThis->ExternalRelease();
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::QueryInterface(
    REFIID iid, void FAR* FAR* ppvObj)
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)
    return (HRESULT)pThis->ExternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::GetLCID(LCID* plcid)
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)

	return E_NOTIMPL;
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::GetItemInfo(
            /* [in] */ LPCOLESTR pstrName,
            /* [in] */ DWORD dwReturnMask,
            /* [out] */LPUNKNOWN* ppiunkItem,
            /* [out] */LPTYPEINFO* ppti)
{
	HRESULT hr = S_OK; 

    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)
	USES_CONVERSION;

	TRACE("GetItemInfo: Name = %s Mask = %x\n", OLE2CT(pstrName), dwReturnMask);

	if (dwReturnMask & SCRIPTINFO_ITYPEINFO)
	{
		if (!ppti)
			return E_INVALIDARG;
		*ppti = NULL;
	}

	if (dwReturnMask & SCRIPTINFO_IUNKNOWN)
	{
		if (!ppiunkItem)
			return E_INVALIDARG;
		*ppiunkItem = NULL;
	}

	// Global object
	if (!_wcsicmp(L"Scripter", pstrName))
	{
		if (dwReturnMask & SCRIPTINFO_ITYPEINFO)
		{
			pThis->GetTypeInfoOfGuid(0 /* lcid unknown! */, CLSID_MfcaxscrvbDlg, ppti);
			(*ppti)->AddRef();      // because returning
		}
		
		if (dwReturnMask & SCRIPTINFO_IUNKNOWN)
		{
			*ppiunkItem = pThis->GetIDispatch(TRUE);
			(*ppiunkItem)->AddRef();    // because returning
		}
		return S_OK;
	}

	// Check map for named item
	CCmdTarget* pdispimpl = NULL;
	if (!(pThis->mapNamedItems.Lookup(OLE2CT(pstrName), (CObject*&) pdispimpl)))
	{
		return TYPE_E_ELEMENTNOTFOUND;
	}

	LPUNKNOWN pUnk = NULL;
	ASSERT(NULL != pdispimpl);
	if (pdispimpl->IsKindOf(RUNTIME_CLASS(CCmdTargetPlus)))
		// Automation class
		pUnk = pdispimpl->GetIDispatch(TRUE);
	else
		// Wrapper Class probably
		pUnk = ((CWnd*)pdispimpl)->GetControlUnknown();

	if (NULL == pUnk)
	{
		TRACE("No IUnknown for item!\n");
		// This shouldn't ever happen, since we're providing the items
		return E_FAIL;
	}

	if (dwReturnMask & SCRIPTINFO_ITYPEINFO)
	{
		// Use IProvideClassInfo to get ITypeInfo of coclass!
		IProvideClassInfo *pci = NULL;
		hr = pUnk->QueryInterface(IID_IProvideClassInfo, (void**)&pci);
		if (SUCCEEDED(hr) && pci)
			hr = pci->GetClassInfo(ppti);
		if (FAILED(hr))
			return E_FAIL;
	}
	
	if (dwReturnMask & SCRIPTINFO_IUNKNOWN)
	{
		*ppiunkItem = pUnk;
		(*ppiunkItem)->AddRef();    // because returning
	}

	return S_OK;
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::GetDocVersionString(LPBSTR pbstrVersion)
{
	METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)

	return E_NOTIMPL;

}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::OnScriptTerminate( 
            /* [in] */ const VARIANT* pvarResult,
            /* [in] */ const EXCEPINFO* pexcepinfo)
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)

	return S_OK;

}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::OnStateChange( 
            /* [in] */ SCRIPTSTATE ssScriptState)
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)

	return S_OK;
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::OnScriptError( 
            /* [in] */ IActiveScriptError* pse)
{
	METHOD_PROLOGUE_EX(CMfcaxscrvbDlg, ActiveScriptSite)

	EXCEPINFO ei;
	DWORD     dwSrcContext;
	ULONG     ulLine;
	LONG      ichError;
	BSTR      bstrLine = NULL;
	CString strError;

	pse->GetExceptionInfo(&ei);
	pse->GetSourcePosition(&dwSrcContext, &ulLine, &ichError);
	pse->GetSourceLineText(&bstrLine);
	
	CString desc;
	CString src;

	desc = (LPCWSTR)ei.bstrDescription;
	src = (LPCWSTR)ei.bstrSource;

	strError.Format("%s\nSrc: %s\nLine:%d Error:%d Scode:%x", desc, src, ulLine, (int)ei.wCode, ei.scode);
	AfxMessageBox(strError);

	TRACE(strError);
	TRACE("\n");

	return S_OK;
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::OnEnterScript()
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)
	TRACE("OnEnterScript\n");

	return S_OK;
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSite::OnLeaveScript()
{
    METHOD_PROLOGUE(CMfcaxscrvbDlg, ActiveScriptSite)
	TRACE("OnLeaveScript\n");

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// IActiveScriptSiteWindow Implementation

STDMETHODIMP_(ULONG) CMfcaxscrvbDlg::XActiveScriptSiteWindow::AddRef()
{
    METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteWindow)
    return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG) CMfcaxscrvbDlg::XActiveScriptSiteWindow::Release()
{
    METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteWindow)
    return pThis->ExternalRelease();
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteWindow::QueryInterface(REFIID iid, LPVOID* ppvObj)
{
    METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteWindow)
    return pThis->ExternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteWindow::EnableModeless(BOOL fEnable)
{
    METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteWindow)
	
	CWinApp* pApp = AfxGetApp();
	if (!pApp)
		return E_FAIL;

	pApp->EnableModeless(fEnable);
	return S_OK;
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteWindow::GetWindow(HWND* phWnd)
{
    METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteWindow)

	CWnd* pWnd = AfxGetMainWnd();
	if (!(pWnd))
		return E_FAIL;

	*phWnd = pWnd->GetSafeHwnd();
	if (*phWnd)
		return S_OK;
	else
		return E_FAIL;
}

/////////////////////////////////////////////////////////////////////////////
// IActiveScriptSiteDebug Implementation
STDMETHODIMP_(ULONG) CMfcaxscrvbDlg::XActiveScriptSiteDebug::AddRef()
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)
   return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG) CMfcaxscrvbDlg::XActiveScriptSiteDebug::Release()
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)
   return pThis->ExternalRelease();
}

STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteDebug::QueryInterface(REFIID iid, LPVOID* ppvObj)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)
   return pThis->ExternalQueryInterface(&iid, ppvObj);
}

// Used by the language engine to delegate IDebugCodeContext::GetSourceContext. 
STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteDebug::GetDocumentContextFromPosition(
      DWORD dwSourceContext,// As provided to ParseScriptText 
                            // or AddScriptlet 
      ULONG uCharacterOffset,// character offset relative 
                             // to start of script block or scriptlet 
      ULONG uNumChars,// Number of characters in context 
                      // Returns the document context corresponding to this character-position range. 
      IDebugDocumentContext **ppsc)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)

   ULONG ulStartPos = 0;
   HRESULT hr;

   if (pThis->m_pDebugDocHelper)
   {
      hr = pThis->m_pDebugDocHelper->GetScriptBlockInfo(dwSourceContext, NULL, &ulStartPos, NULL);
      hr = pThis->m_pDebugDocHelper->CreateDebugDocumentContext(ulStartPos + uCharacterOffset, uNumChars, ppsc);
   }
   else
   {
      hr = E_NOTIMPL;
   }

	return hr;
}

// Returns the debug application object associated with this script site. Provides 
// a means for a smart host to define what application object each script belongs to. 
// Script engines should attempt to call this method to get their containing application 
// and resort to IProcessDebugManager::GetDefaultApplication if this fails. 
STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteDebug::GetApplication( 
      IDebugApplication **ppda)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)
   if (!ppda)
   {
      return E_INVALIDARG;
   }

   // bugbug - should addref to this ?
   if (pThis->m_pDebugApp)
   {
      ULONG ul = pThis->m_pDebugApp->AddRef();
   }

   *ppda = pThis->m_pDebugApp;

	return S_OK;
}

// Gets the application node under which script documents should be added 
// can return NULL if script documents should be top-level. 
STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteDebug::GetRootApplicationNode( 
      IDebugApplicationNode **ppdanRoot)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)

   if (!ppdanRoot)
   {
      return E_INVALIDARG;
   }

   if (pThis->m_pDebugDocHelper)
   {
      return pThis->m_pDebugDocHelper->GetDebugApplicationNode(ppdanRoot);
   }

   return E_NOTIMPL;
}

// Allows a smart host to control the handling of runtime errors 
STDMETHODIMP CMfcaxscrvbDlg::XActiveScriptSiteDebug::OnScriptErrorDebug( 
      // the runtime error that occurred 
      IActiveScriptErrorDebug *pErrorDebug, 
      // whether to pass the error to the debugger to do JIT debugging 
      BOOL*pfEnterDebugger, 
      // whether to call IActiveScriptSite::OnScriptError() when the user 
      // decides to continue without debugging 
      BOOL *pfCallOnScriptErrorWhenContinuing)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, ActiveScriptSiteDebug)
   if (pfEnterDebugger)
   {
      *pfEnterDebugger = TRUE;
   }
   if (pfCallOnScriptErrorWhenContinuing)
   {
      *pfCallOnScriptErrorWhenContinuing = TRUE;
   }
   return S_OK;
}





/////////////////////////////////////////////////////////////////////////////
// IDebugDocumentHost Implementation

// Return a particular range of characters in the original host document, 
// added using AddDeferredText. 
// 
// It is acceptable for a host to return E_NOTIMPL for this method, 
// as long as the host doesn't call AddDeferredText. 
// 
// (Note that this is text from the _original_ document. The host 
// does not need to be responsible for keeping track of edits, etc.) 
STDMETHODIMP_(ULONG) CMfcaxscrvbDlg::XDebugDocumentHost::AddRef()
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)
   return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG) CMfcaxscrvbDlg::XDebugDocumentHost::Release()
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)
   return pThis->ExternalRelease();
}

STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::QueryInterface(REFIID iid, LPVOID* ppvObj)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)
   return pThis->ExternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::GetDeferredText( 
      DWORD dwTextStartCookie, 
      // Specifies a character text buffer. NULL means do not return characters. 
      WCHAR *pcharText, 
      // Specifies a character attribute buffer. NULL means do not return attributes. 
      SOURCE_TEXT_ATTR *pstaTextAttr, 
      // Indicates the actual number of characters/attributes returned. Must be set to zero 
      // before the call. 
      ULONG *pcNumChars, 
      // Specifies the number maximum number of character desired. 
      ULONG cMaxChars) 
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)

   return E_NOTIMPL;
}

// Return the text attributes for an arbitrary block of document text. 
// It is acceptable for hosts to return E_NOTIMPL, in which case the 
// default attributes are used. 
STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::GetScriptTextAttributes( 
      // The script block text. This string need not be null terminated. 
      LPCOLESTR pstrCode, 
      // The number of characters in the script block text. 
      ULONG uNumCodeChars, 
      // See IActiveScriptParse::ParseScriptText for a description of this argument. 
      LPCOLESTR pstrDelimiter, 
      // See IActiveScriptParse::ParseScriptText for a description of this argument. 
      DWORD dwFlags, 
      // Buffer to contain the returned attributes. 
      SOURCE_TEXT_ATTR *pattr) 
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)

   return E_NOTIMPL;
}

// Notify the host that a new document context is being created 
// and allow the host to optionally return a controlling unknown 
// for the new context. 
// 
// This allows the host to add new functionality to the helper-provided 
// document contexts. It is acceptable for the host to return E_NOTIMPL 
// or a null outer unknown for this method, in which case the context is 
// used "as is". 
STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::OnCreateDocumentContext( 
      IUnknown** ppunkOuter) 
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)

   return E_NOTIMPL;
}

// Return the full path (including file name) to the document's source file. 
//*pfIsOriginalPath is TRUE if the path refers to the original file for the document. 
//*pfIsOriginalPath is FALSE if the path refers to a newly created temporary file 
//Returns E_FAIL if no source file can be created/determined. 
STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::GetPathName( 
      BSTR *pbstrLongName, 
      BOOL *pfIsOriginalFile)
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)

   *pbstrLongName = pThis->m_strCurrentFilePath.AllocSysString();
   *pfIsOriginalFile = TRUE;

   return S_OK;
}

// Return just the name of the document, with no path information. 
// (Used for "Save As...") 
STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::GetFileName( 
      BSTR *pbstrShortName) 
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)

   // bugbug - shorten name !
   *pbstrShortName = pThis->m_strCurrentFilePath.AllocSysString();

   return S_OK;
}

// Notify the host that the document's source file has been saved and 
// that its contents should be refreshed. 
STDMETHODIMP CMfcaxscrvbDlg::XDebugDocumentHost::NotifyChanged()
{
   METHOD_PROLOGUE_EX_(CMfcaxscrvbDlg, DebugDocumentHost)

   return S_OK;
}


/////////////////////////////////////////////////////////////////////////////
// CLSID for ProcessDebugManager
// {78A51822-51F4-11D0-8F20-00805F2CD064}
static const GUID CLSID_ProcessDebugManager =
{ 0x78a51822, 0x51f4, 0x11d0, { 0x8f, 0x20, 0x0, 0x80, 0x5f, 0x2c, 0xd0, 0x64 } };


/////////////////////////////////////////////////////////////////////////////
// CMfcaxscrvbDlg message handlers

BOOL CMfcaxscrvbDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_wndBroCon.GoHome();

   // XX ActiveX Scripting with debug support XX
	// Initialise the pdm
   HRESULT hr = CoCreateInstance(CLSID_ProcessDebugManager, 
                                 NULL, 
                                 CLSCTX_INPROC_SERVER | /*CLSCTX_INPROC_HANLDER | */CLSCTX_LOCAL_SERVER,
                                 IID_IProcessDebugManager,
                                 (void**)&m_pdm);
   if (!SUCCEEDED(hr))
   {
      AfxMessageBox(_T("Unable to initialise scripting control"));
      TRACE(_T("Unable to initialise scripting control\n"));
      return FALSE;
   }

   ASSERT(m_pdm);

	// Initialise the application
   hr = m_pdm->CreateApplication(&m_pDebugApp);
   if (!SUCCEEDED(hr))
   {
      AfxMessageBox(_T("Unable to initialise scripting control"));
      TRACE(_T("Unable to initialise scripting control\n"));
      return FALSE;
   }

   ASSERT(m_pDebugApp);
   hr = m_pDebugApp->SetName(L"MFC Scripting Application");
   if (!SUCCEEDED(hr))
   {
      AfxMessageBox(_T("Unable to initialise scripting control"));
      TRACE(_T("Unable to initialise scripting control\n"));
      return FALSE;
   }

   hr = m_pdm->AddApplication(m_pDebugApp, &m_dwAppCookie);
   if (!SUCCEEDED(hr))
   {
      AfxMessageBox(_T("Unable to initialise scripting control"));
      TRACE(_T("Unable to initialise scripting control\n"));
      return FALSE;
   }

	return TRUE;  // return TRUE  unless you set the focus to a control

}

void CMfcaxscrvbDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMfcaxscrvbDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcaxscrvbDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// If a script is currently running, stop it
// else, start a script running based on the text in the edit control
void CMfcaxscrvbDlg::OnRunScript() 
{
	CString strScriptText;
	EXCEPINFO    ei;
	HRESULT hr;

   UpdateData();

	// RunScript button clicked!
	m_xRunScriptDispatch.FireOnClick();

	if (m_bScriptIsRunning)
	{
		// Close Script
		hr = m_axs->Close();
		if (FAILED(hr))
		{
			TRACE("Attempt to Close AXS failed\n");
			goto FailedToStopScript;
		}
		// NOTE: Handle OLESCRIPT_S_PENDING
		// The documentation reports that if you get this return value,
		// you'll need to wait until IActiveScriptSite::OnStateChange before
		// finishing the Close. However, no current script engine implementation
		// will do this and this return value is not defined in any headers currently
		// (This is true as of IE 3.01)

		if (m_axsp)
		{
			m_axsp->Release();
			m_axsp = NULL;
		}
		if (m_axs)
		{
			m_axs->Close();
			m_axs->Release();
			m_axs = NULL;
		}
      if (m_pDebugDocHelper)
      {
         m_pDebugDocHelper->Detach();
         m_pDebugDocHelper->Release();
         m_pDebugDocHelper = NULL;
      }

		m_wndRunScript.SetWindowText("&Run Script");
		m_bScriptIsRunning = FALSE;
		return;

FailedToStopScript:
#ifndef DEBUG
		AfxMessageBox("Attempt to stop running script failed!\n");
#endif
		return;
	}
	else
	{
		if (!CreateEngine())
		{
#ifndef DEBUG
			AfxMessageBox("Failed to create script engine. Cannot execute script.");
#endif
			TRACE("Failed to create script engine. Cannot execute script.");
			return;
		}

		// Get text from edit control and PARSE IT DUDE!!
		m_wndEditCon.GetWindowText(strScriptText);

		BSTR bstrParseMe = strScriptText.AllocSysString();
      
      ASSERT(m_pDebugDocHelper);

      hr = m_pDebugDocHelper->AddDBCSText(strScriptText);
      if (!SUCCEEDED(hr))
      {
		   TRACE(_T("Problem adding text to the debug document\n"));
         ASSERT(0);
      }

      DWORD dw;
      hr = m_pDebugDocHelper->DefineScriptBlock(0, strScriptText.GetLength(), m_axs, FALSE, &dw);
      if (!SUCCEEDED(hr))
      {
		   TRACE(_T("Problem adding text to the debug document\n"));
         ASSERT(0);
      }
		hr = m_axsp->ParseScriptText(bstrParseMe, L"Scripter", NULL, NULL, dw, 0, 0L, NULL, &ei);

      if (m_bBreakOnStart)
      {
         hr = m_pDebugDocHelper->BringDocumentToTop();
		   if (FAILED(hr))
		   {
			   TRACE(_T("Failed to start debugger session\n"));
		   }

         hr = m_pDebugApp->CauseBreak();
		   if (FAILED(hr))
		   {
			   TRACE(_T("Failed to break execution\n"));
		   }
      }

		// Start the script running...
		hr = m_axs->SetScriptState(SCRIPTSTATE_CONNECTED);
		if (FAILED(hr))
		{
			TRACE("SetScriptState to CONNECTED failed\n");
		}

		// Change Button Text to "&Stop Script"
		m_wndRunScript.SetWindowText("&Stop Script");
		m_bScriptIsRunning = TRUE;
	}
}


void CMfcaxscrvbDlg::OnBbuttonClicked() 
{
	m_xBButtonDispatch.FireOnClick();	
}

// XX ActiveX Scripting Debugging XX
void CMfcaxscrvbDlg::OnOpenDebugger() 
{
   ASSERT(m_pDebugApp);

   HRESULT hr = m_pDebugApp->StartDebugSession();

	if (FAILED(hr))
	{
		TRACE(_T("Failed to start debugger session\n"));
      return;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMfcaxscrvbDlg dispatch and event handlers

LPDISPATCH CMfcaxscrvbDlg::GetBroCon() 
{
	// no dispatch pointer yet; find it now
	LPDISPATCH pDispatch = NULL;
	LPUNKNOWN pUnkControl = m_wndBroCon.GetControlUnknown();

	if ((pUnkControl != NULL) &&
		SUCCEEDED(pUnkControl->QueryInterface(IID_IDispatch, (LPVOID*)&pDispatch)))
	{
		ASSERT(pDispatch != NULL);
	}
	else
	{
		TRACE("Failed to obtain dispatch for Web Browser Control");
	}

	return pDispatch;
}


LPDISPATCH CMfcaxscrvbDlg::GetEditCon() 
{
	return m_xEditConDispatch.GetIDispatch(TRUE);
}

LPDISPATCH CMfcaxscrvbDlg::GetAButton() 
{
	return m_xAButtonDispatch.GetIDispatch(TRUE);
}

LPDISPATCH CMfcaxscrvbDlg::GetBButton() 
{
	return m_xBButtonDispatch.GetIDispatch(TRUE);
}

LPDISPATCH CMfcaxscrvbDlg::GetLBox() 
{
	return m_xLBoxDispatch.GetIDispatch(TRUE);
}

LPDISPATCH CMfcaxscrvbDlg::GetScriptButton() 
{
	return m_xRunScriptDispatch.GetIDispatch(TRUE);
}

LPDISPATCH CMfcaxscrvbDlg::GetOKButton() 
{
	return m_xOKDispatch.GetIDispatch(TRUE);
}

LPDISPATCH CMfcaxscrvbDlg::GetCancelButton() 
{
	return m_xCancelDispatch.GetIDispatch(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// CMfcaxscrvbDlg Faked CreateObject implementation

LPDISPATCH CMfcaxscrvbDlg::HostCreateObject(const VARIANT FAR& bstrProgID) 
{
	USES_CONVERSION;

	HRESULT hr = S_OK;
	LPDISPATCH retval = NULL;
	TRACE( "Calling HostCreateObject()\n" );

	if (VT_BSTR != bstrProgID.vt)
	{
		AfxThrowOleException(E_INVALIDARG);
	}

	CLSID clsidObject;
	hr = CLSIDFromProgID( (LPCOLESTR)bstrProgID.pbstrVal, &clsidObject );
	if( SUCCEEDED( hr ) )
	{
		hr = CoCreateInstance( clsidObject, NULL, CLSCTX_LOCAL_SERVER, IID_IDispatch, (void**)&retval );
		if (FAILED(hr))
		{
			CString strProgID;
			strProgID = (BSTR)bstrProgID.pbstrVal;
			TRACE("Failed to create object '%s'.\nReturn = 0x%x\n",strProgID,hr);
			AfxThrowOleException(E_FAIL);
		}
	}
	else
	{
		CString strProgID;
		strProgID = (BSTR)bstrProgID.pbstrVal;
		TRACE("Invalid ProgID '%s'\n",strProgID);
		AfxThrowOleException(E_INVALIDARG);
	}

	return retval;
}

BOOL CMfcaxscrvbDlg::CreateEngine()
{
	HRESULT hr;
   USES_CONVERSION;

	// Check we have a process debug manager
   ASSERT(m_pdm);

	// XX ActiveX Scripting XX 
	hr = CoCreateInstance(CLSID_VBScript, NULL, CLSCTX_INPROC_SERVER, IID_IActiveScript, (void **)&m_axs);
	if (FAILED(hr))
		// If this happens, the scripting engine is probably not properly registered
		return FALSE;

	// Script Engine must support IActiveScriptParse for us to use it
	hr = m_axs->QueryInterface(IID_IActiveScriptParse, (void **)&m_axsp);
	if (FAILED(hr))
		goto Failure;
	hr = m_axs->SetScriptSite(&m_xActiveScriptSite); // Our MFC-OLE interface implementation
	if (FAILED(hr))
		goto Failure;
	// InitNew the object:
	hr = m_axsp->InitNew();
	if (FAILED(hr))
		goto Failure;

	mapNamedItems[_T("Scripter")] = this;
	// Add Top-level Global Named Item
	hr = m_axs->AddNamedItem(L"Scripter", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE | SCRIPTITEM_GLOBALMEMBERS);
	if (FAILED(hr))
		TRACE("Couldn't add named item Scripter\n");

	// NOTE: Here's a tricky point in the scripting object model stuff
	// Technically, all a scripting host needs to do is expose the top level items
	// in its hierarchy. In our case, thats the Scripter object, since all of the following
	// are available as properties in the Scripter IDispatch interface.
	// We do not need to add these as named items for script code such as
	// 'LBox.AddString "Hi There"'
	// to work without doing 'Scripter.LBox.AddString "Hi There"'
	// However! script engines will only set up sinks for Named Items. So if you
	// want an item to be able to support event-handling such as
	// "Sub LBox_OnMouseOver"
	// you must add that item as a Named Item. In this case, everything on the dialog
	// generates events that we might want to script, so we add all items as named
	// items.
	mapNamedItems[_T("AButton")] = &m_xAButtonDispatch;
	hr = m_axs->AddNamedItem(L"AButton", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item AButton\n");
	mapNamedItems[_T("BButton")] = &m_xBButtonDispatch;
	hr = m_axs->AddNamedItem(L"BButton", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item BButton\n");
	mapNamedItems[_T("LBox")] = &m_xLBoxDispatch;
	hr = m_axs->AddNamedItem(L"LBox", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item LBox\n");
	mapNamedItems[_T("EditCon")] = &m_xEditConDispatch;
	hr = m_axs->AddNamedItem(L"EditCon", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item EditCon\n");
	mapNamedItems[_T("RunScript")] = &m_xRunScriptDispatch;
	hr = m_axs->AddNamedItem(L"RunScript", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item RunScript\n");
	mapNamedItems[_T("CancelButton")] = &m_xCancelDispatch;
	hr = m_axs->AddNamedItem(L"CancelButton", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item CancelButton\n");
	mapNamedItems[_T("OKButton")] = &m_xOKDispatch;
	hr = m_axs->AddNamedItem(L"OKButton", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item OKButton\n");
	// Web Browser Control
	mapNamedItems[_T("BroCon")] = &m_wndBroCon;
	hr = m_axs->AddNamedItem(L"BroCon", SCRIPTITEM_ISVISIBLE | SCRIPTITEM_ISSOURCE);
	if (FAILED(hr))
		TRACE("Couldn't add named item BroCon\n"); 

// XX ActiveX Scripting with debug support XX
   ASSERT(!m_pDebugDocHelper);
   hr = m_pdm->CreateDebugDocumentHelper(NULL, &m_pDebugDocHelper);
   if (!SUCCEEDED(hr))
   {
    	TRACE(_T("Failed to create debug document.\n"));
		goto Failure;
   }

   ASSERT(m_pDebugDocHelper);

   hr = m_pDebugDocHelper->Init(m_pDebugApp, L"Current Text", L"MFC Scripted Current Text", TEXT_DOC_ATTR_READONLY);
   if (!SUCCEEDED(hr))
   {
    	TRACE(_T("Failed to create debug document.\n"));
		goto Failure;
   }

   hr = m_pDebugDocHelper->Attach(NULL);
   if (!SUCCEEDED(hr))
   {
    	TRACE(_T("Failed to create debug document.\n"));
		goto Failure;
   }

   hr = m_pDebugDocHelper->SetDocumentAttr(TEXT_DOC_ATTR_READONLY);
   if (!SUCCEEDED(hr))
   {
    	TRACE(_T("Failed to create debug document.\n"));
		goto Failure;
   }

   // this step is optional but it deosn't require much effort to perform
   hr = m_pDebugDocHelper->SetDebugDocumentHost(&(this->m_xDebugDocumentHost));
   if (!SUCCEEDED(hr))
   {
    	TRACE(_T("Failed to create debug document.\n"));
		goto Failure;
   }

	return TRUE;

Failure:
	if (m_axs)
   {
		m_axs->Release();
      m_axs = NULL;
   }
	if (m_axsp)
   {
		m_axsp->Release();
      m_axsp = NULL;
   }
	if (m_pDebugDocHelper)
   {
		m_pDebugDocHelper->Release();
      m_pDebugDocHelper = NULL;
   }

	// XX ActiveX Scripting XX
	return FALSE;
}

