	// RunScriptDispatch.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "RunScriptDispatch.h"
#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Note: we add support for IID_IRunScriptDispatch to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {B2C1A346-4F18-11D0-A1AE-000000000000}
static const IID IID_IRunScriptDispatch =
{ 0xb2c1a346, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {B2C1A347-4F18-11D0-A1AE-0000000000000}
static const IID IID_IRunScriptEvents =
{ 0xb2c1a347, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {B2C1A348-4F18-11D0-A1AE-000000000000}
// coclass!
static const GUID CLSID_RunScript =
{ 0xb2c1a348, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// Use OLETYPELIB of master dialog?
IMPLEMENT_OLETYPELIB(CRunScriptDispatch, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// CRunScriptDispatch

IMPLEMENT_DYNCREATE(CRunScriptDispatch, CButtonDispatch)

CRunScriptDispatch::CRunScriptDispatch()
{
	m_piidEvents = &IID_IRunScriptEvents;
	m_piidPrimary = &IID_IRunScriptDispatch;
}

CRunScriptDispatch::~CRunScriptDispatch()
{
}


void CRunScriptDispatch::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CButtonDispatch::OnFinalRelease();
}

HRESULT CRunScriptDispatch::GetClassID(LPCLSID pclsid)
{
	*pclsid = CLSID_RunScript;
	return NOERROR;
}

BEGIN_MESSAGE_MAP(CRunScriptDispatch, CButtonDispatch)
	//{{AFX_MSG_MAP(CRunScriptDispatch)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CRunScriptDispatch, CButtonDispatch)
	//{{AFX_DISPATCH_MAP(CRunScriptDispatch)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CRunScriptDispatch, CButtonDispatch)
	INTERFACE_PART(CRunScriptDispatch, IID_IRunScriptDispatch, Dispatch)
END_INTERFACE_MAP()

BEGIN_EVENT_MAP(CRunScriptDispatch, CButtonDispatch)
	//{{AFX_EVENT_MAP(CRunScriptDispatch)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRunScriptDispatch message handlers


